`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/03/19 16:30:11
// Design Name: 
// Module Name: topmodule
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

module topmodule(
    D_ssd,
    ssd_ctl,
    clk,
    //rst,
    //rst_count,
    LED_out,
    pb_in
    );

    output [7:0] D_ssd;
    output [3:0] ssd_ctl;
    output [15:0] LED_out;
    input clk;
    //input rst;
    input pb_in;
    //input rst_count;
    
    wire clk_1Hz;
    wire clk_100Hz;
    wire [1:0] clk_ssd_ctl;
   

    wire pb_debounced;
    wire pb_out_1_pulse;
    wire count_enable;
    wire current_state;

    wire rst_count;
    wire pb_press_long;

    wire [3:0] digit_0, digit_1;
    wire LED_in;

    wire [3:0] ssd_in;
   

    clock_generator U0(
    .clk_1Hz(clk_1Hz), //divided clock output
    .clk_100Hz(clk_100Hz),
    .clk_ctl(clk_ssd_ctl), //clock for 7-segment
    .clk(clk),    //clock input
    .rst(rst_count)   //low-active reset
);
    debounce U1( 
    .rst(rst_count), 
    .clk(clk_100Hz), 
    .pb_in(pb_in),
    .pb_debounced(pb_debounced)
);
    press_long U11( 
    .pb_press_long(pb_press_long),
    .rst_count(rst_count),
    .rst(rst_count),
    .pb_debounce_in(pb_debounced),
    .clk(clk)
);
    one_pulse U2( 
    .rst(rst_count), 
    .clk(clk_100Hz), 
    .in_trig(pb_press_long),
    .out_pulse(pb_out_1_pulse) 
);
    fsm U3(
    .count_enable(count_enable),
    .in(pb_out_1_pulse),
    .clk(clk_100Hz),
    .rst(rst_count),
    .curr_state(current_state)
);

    BCD_down_2d U4(
    .digit_1(digit_1),
    .digit_0(digit_0),
    .clk(clk_1Hz),
    .rst(rst_count),
    .en(count_enable),
    .LED_out_to_ctl(LED_in)
    );

    LED_ctl U5( 
    .current_state(current_state),
    .LED_in(LED_in),
    .LED_out(LED_out)
);
    scan_freq_ctl U6(
    .ssd_in(ssd_in),
    .ssd_ctl(ssd_ctl),
    .in_0(digit_0),
    .in_1(digit_1),
    .clk_ctl_en(clk_ssd_ctl),
    .rst(rst_count)
    );
    
    display U7(.D_ssd(D_ssd), .i(ssd_in));
    
    
endmodule
